require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xjeaendpoint',
  dscmeta_resource_friendly_name: 'xJeaEndPoint',
  dscmeta_resource_name: 'MSFT_xJeaEndpoint',
  dscmeta_module_name: 'xJea',
  dscmeta_module_version: '0.2.5',
  docs: 'The DSC xJeaEndPoint resource type.
         Automatically generated from version 0.2.5',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_name: {
      type: 'String',
      desc: 'Name of the JEA toolkit to be generated',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_cleanall: {
      type: 'Optional[Boolean]',
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_group: {
      type: 'Optional[Array[String]]',
      desc: 'List of local groups that this Endpoints JeaSessionAccount should be a member of',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_securitydescriptorsddl: {
      type: 'Optional[String]',
      desc: 'Sddl to define who can access this JeaEndpoint',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_toolkit: {
      type: 'Optional[Array[String]]',
      desc: 'List of Jea Toolkits to make available via this endpoint',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
  },
)
