require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xjeatoolkit',
  dscmeta_resource_friendly_name: 'xJeaToolKit',
  dscmeta_resource_name: 'MSFT_xJeaToolkit',
  dscmeta_module_name: 'xJea',
  dscmeta_module_version: '0.2.5',
  docs: 'The DSC xJeaToolKit resource type.
         Automatically generated from version 0.2.5',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_commandspecs: {
      type: 'Optional[String]',
      desc: 'CSV formated list of command specifications',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_scriptdirectory: {
      type: 'Optional[Array[String]]',
      desc: 'array of script directories that can be run',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_name: {
      type: 'String',
      desc: 'Name of the JEA toolkit to be generated',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_applications: {
      type: 'Optional[Array[String]]',
      desc: 'Array of executables that are allowed to run',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
  },
)
